/**************************************************
*  dd  HI-TECHo[W
*   o͓dƏo͓d̑
**************************************************/
#include  <htc.h>
#include  "lcd_lib.h"

// RtBM[V̒`
/***** RtBM[V̐ݒ ********/
__CONFIG(INTIO & WDTDIS & PWRTEN & BOREN & MCLREN 
		& DUNPROTECT & UNPROTECT & IESODIS & FCMDIS);

void delay_100ms(unsigned int count);
void ltostring(char digit, unsigned long data, char *buffer);
/*** 萔Aϐ̐錾` ****/
unsigned long Volt, Current;
char VltMsg[] = "Volt =  xx.x V  ";
char CurMsg[] = "Curr = xxxx mA  ";
unsigned char StMsg[] = "Start Power Unit";	
/* [U` */
const unsigned char User1[8] = {0x00,0x00,0x00,0x00,0x1F,0x1F,0x1F,0x00};
const unsigned char User2[8] = {0x1F,0x1F,0x1F,0x00,0x00,0x00,0x00,0x00};

/*********** C֐ **************/
void main(void)
{
	int i, Flag;

	// o̓[hݒ
	TRISA = 0x18;							// PORTA@MCLR(RA3),RA4ȊOSo	
	TRISB = 0x30;							// RB4,5̂ݓ
	TRISC = 0xCF;							// IyAvAZT֘A,RC4,5 Out
	PORTB = 0;							// lo
	PORTC = 0;
	OPA1CON = 0x80;						// OP AMPgݒ
	OPA2CON = 0x80;
	// ADC̐ݒ
	ANSEL0 = 0x38;						// AN3,4,5
	ANSEL1 = 0;
	ADCON0 = 0x8C;						// E߁AADIt
	ADCON1 = 0x50;						// 1/16 AD clock
	// LCDƊJnbZ[WLCD\
	lcd_init();
	lcd_cgram(1, User1);					// [U`
	lcd_cgram(2, User2);
	lcd_clear();
	lcd_str(StMsg);
	delay_100ms(5);						// 0.5bԕ\
	/********* C[v *************/
	while(1)
	{
		/*** d(10̕) ****/
		Volt = 0;						// lNA
		for(i=0; i<10; i++){				// 10̕
			ADCON0 = 0x8D;				// AN3 dI
			__delay_us(50);				// ANCWV^C
			GODONE = 1;
			while(GODONE);
			Volt += (ADRESH*256+ADRESL);	// f[^
		}
		Volt /= 10;						// ς߂
		// XP[ϊ 5V~6.1i)= 30.5@
		Volt = (Volt * 305) / 1024  ;
		// dPʂŕ\o
		ltostring(3, Volt, VltMsg+8);		// 3̕ɕϊ
		VltMsg[11] = VltMsg[10];			// ŉʂE1炷
		VltMsg[10] = '.';					// _ǉ
		lcd_cmd(0x80);					// 1sڎw
		lcd_str(VltMsg);					// dl\

		/*** d(10̕)  *****/
		Current = 0;						// lNA
		for(i=0; i<10; i++){				// 10̕
			ADCON0 = 0x91;				// AN4 200{QCI
			__delay_us(50);				// 50usec҂
			GODONE = 1;
			while(GODONE);	
			Current += (ADRESH*256+ADRESL);	// dǂݍ
		}
		if(Current < 30)
			Current = 0;
		else{
			if(Current < 10000){				// dH
				RB6 = 1;						// ڈLED Off
				// XP[ƕϊAItZbg
				Current = (Current*20)/1024 + 15;
			}
			else{							// d̏ꍇ
				RB6 = 0;						// ڈLED On
				Current = 0;
				for(i=0; i<10; i++){			// 10̕
					ADCON0 = 0x95;			// AN5 20{QCI
					__delay_us(50);			// 50usec҂	
					GODONE = 1;
					while(GODONE);	
					Current += (ADRESH*256+ADRESL);// dǂݍ
				}
				// XP[ƕϊ@ItZbg(@Œj
				Current = (Current*214)/1024 + 19;
			}
		}
		// Βl10i\
		ltostring(4, Current, CurMsg+7);	// ɕϊ
		lcd_cmd(0xC0);					// 2sڂw
		lcd_str(CurMsg);					// dl\
		/*** ڈ\ ****/
		lcd_cmd(0xCF);					// 2sڂ̍Ōw
		if(Current > 30){					// d30mAȏォH
			if(Flag){					// FlagŌݐؑ
				lcd_data(0x01);			// [U[1\
				Flag = 0;				// tOؑ
			}
			else{
				lcd_data(0x02);			// [U[2\
				Flag = 1;				// tOؑ
			}
		}
		else
			lcd_data(0x20);				// 30mAȉȂ	
		// 0.5b҂
		delay_100ms(5);
	}
}
/***************************************
* longASCIIɕϊ
****************************************/
void ltostring(char digit, unsigned long data, char *buffer)
{
	char i;

	buffer += digit;					// Ō̐ʒu
	for(i=digit; i>0; i--) {			// ϊ͉ʂʂ
		buffer--;					// |C^[P
		*buffer = (data % 10) + '0';	// ASCII
		data = data / 10;				// ̌
	}
}
/************************************
*  100msecx֐
*************************************/
void delay_100ms(unsigned int count)
{
	count *= 4;					// 4{
	while(count != 0)
	{
		__delay_ms(25);			// 25msec
		count--;					// 100msec x time
	}
}
