///////////////////////////////////////////////
//  t\퐧䃉Cu
//  ֐͈ȉ
//    lcd_init()    ----- 
//    lcd_cmd(cmd)  ----- R}ho
//    lcd_data(chr) ----- P\o
//    lcd_str(ptr)  ----- \o
//    lcd_clear()   ----- S
//////////////////////////////////////////////
#include <htc.h>
#include "lcd_lib.h"


//////// f[^o̓Tu֐
void lcd_out(char code, int flag)
{
	if(code & 0x80)
		DB7 = 1;			//DB7 pin
	else
		DB7 = 0;
	if(code & 0x40)
		DB6 = 1;			//DB6 pin
	else
		DB6 = 0;
	if(code & 0x20)
		DB5 = 1;			//DB5 pin
	else
		DB5 = 0;
	if(code & 0x10)
		DB4 = 1;			//DB4 pin
	else
		DB4 = 0;
	if (flag == 0)
		RS = 1;			//RS pin \f[^̏ꍇ
	else
		RS = 0;			//R}hf[^̏ꍇ
	_delay(1);			//NOP		
	STB = 1;				//E pin STB out
	_delay(2);			//NOP
	STB = 0;				//E pin STB reset
}
//////// P\֐
void lcd_data(char asci)
{
	lcd_out(asci, 0);		//ʂSrbgo
	lcd_out(asci<<4, 0);	//ʂSrbgo
	__delay_us(50);		//50sec҂
}
/////// \֐
void lcd_str(char* ptr)
{
	while(*ptr != 0)		//o 
		lcd_data(*ptr++);	//\
}
/////// R}ho͊֐
void lcd_cmd(char cmd)
{
	lcd_out(cmd, 1);		//ʂSrbgo
	lcd_out(cmd<<4, 1);	//ʂSrbgo
	/* ClearHome */
	if((cmd == 0x01)||(cmd == 0x02))
		__delay_ms(2);	// 2msec҂
	else
		__delay_us(50);	// 50sec҂	
}
/////// S֐
void lcd_clear(void)
{
	lcd_cmd(0x01);			//R}ho
}
/***** CGRAMݒ  *****/
void lcd_cgram(int code, const unsigned char* ptr)
{
	int i;

	for(i=0; i<8; i++){		// 8oCgJԂ
		lcd_cmd(0x40+code*8+i);// CGRAMAhXZbg
		lcd_data(*ptr++);		// 8rbgf[^
	}
}
/////// ֐
void lcd_init(void)
{
	__delay_ms(30);
	lcd_out(0x30, 1);			//8bit mode set
	__delay_ms(5);
	lcd_out(0x30, 1);			//8bit mode set
	__delay_ms(1);
	lcd_out(0x30, 1);			//8bit mode set
	__delay_ms(1);
	lcd_out(0x20, 1);			//4bit mode set
	__delay_ms(1);
	lcd_cmd(0x28);			//DL=0 4bit mode
	lcd_cmd(0x08);			//display off C=D=B=0
	lcd_cmd(0x0D);			//display on C=D=1 B=0
	lcd_cmd(0x06);			//entry I/D=1 S=0
	lcd_cmd(0x02);			//cursor home
}

